/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17
					2025.01.11

	These materials inherit <<CryptOne>>.

	   k.masuda.52431@gmailcom
	  Cell phone : 080-5444-1937

	203 NIC Heim Akabane, 22-31
	Iwabuchi-machi, Kita-ku Tokyo
			Japan	115-0041

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>

These materials inherit <<CryptOne>>

             Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD

                 2024.01
*/

int		main(
int		iArgc,
char	*pcArgv[]
){
	int		iLp0; /* == 0, 1 : two case */
	double	dSum	 = 0.0;
	double	d2Sum	 = 0.0;
	double	dMu		 = 0.0;
	double	dSigma2	 = 0.0;
	double	dSigma	 = 0.0;
	double	dVal = 0.0;
	double	d2Val = 0.0;
	int		iLp1, iLp1Max;
	struct	timeval		stTime;
	int		iTotal = 0;
	int		iMod;
	int		iLp2;
	int		iNo;
	double	dAcc;

	if( iArgc < 4 ){
		fprintf( stderr, "a.out <Num> <Mod> <convolution no.>\n" );
		exit( 1 );
	}

	_TRC_INIT( "99" );
	_TRC_ENTR( "main" );

	gettimeofday( &stTime, 0 );
	Seed5_1( 0, stTime.tv_sec, stTime.tv_usec );
	iLp1Max = atoi( pcArgv[ 1 ] );
	iMod	= atoi( pcArgv[ 2 ] );
	iNo		= atoi( pcArgv[ 3 ] );
	_TRC_DMPD( "iLp1Max", iLp1Max );
	_TRC_DMPD( "iMod", iMod );
	_TRC_DMPD( "iNo", iNo );

	for( iLp0 = 0; iLp0 < 2; iLp0 ++ ){
		if( iLp0 == 0 ){
			for( iLp1 = iTotal = 0, dSum = d2Sum = 0.0;
													iLp1 < iLp1Max; iLp1 ++ ){
				dVal = ( (double)( Rand5_1( 0 ) % iMod )
												/ (double)iMod ) - 0.5;
				_TRC_DMPF( "--->1st case : dVal", dVal );
				d2Val = dVal * dVal;	
				dSum += dVal;
				d2Sum += d2Val;
				iTotal += ( dVal < 0.0 ) ? 0 : 1;
			}
			dMu			= dSum / (double)iLp1Max;
			dSigma2		= d2Sum / (double)iLp1Max - dMu * dMu;
			dSigma		= sqrt( dSigma2 ) /* / (double)iLp1Max */;

			printf( "\n\n-----> First case\n" );
			printf( "iTotal, iCount      = %d, %d\n", iLp1Max, iTotal );
			printf( "Mean, Sigma2, Sigma = %lf, %lf, %lf\n",
												dMu, dSigma2, dSigma );

			sprintf( pcMsg, "Mean = %lf, Sigma = %lf", dMu, dSigma );
			_TRC_DUMP( pcMsg );
		}	
		else{
			for( iLp1 = iTotal = 0, d2Val = dSum = d2Sum = 0.0;
												iLp1 < iLp1Max; iLp1 ++ ){
				for( iLp2 = 0, dAcc = 0.0; iLp2 < iNo; iLp2 ++ ){
					dAcc += ( (double)( Rand5_1( 0 ) % iMod )
												/ (double)iMod ) - 0.5;
				}
				dVal  = dAcc / (double)iNo;
				sprintf( pcMsg, "--->2nd case convolution(%d) : dVal(%lf)",
								iNo, dVal );
				_TRC_DUMP( pcMsg );
				d2Val = dVal * dVal;
				dSum += dVal;
				d2Sum += d2Val;
				iTotal += ( dVal < 0.0 ) ? 0 : 1;
			}
			dMu			= dSum / (double)iLp1Max;
			dSigma2		= d2Sum / (double)iLp1Max - dMu * dMu;
			dSigma		= sqrt( dSigma2 ) /* / (double)iLp1Max */;

			printf( "\n\n-----> Second Convolution(%d) case\n", iNo );
			printf( "iTotal, iCount      = %d, %d\n", iLp1Max, iTotal );
			printf( "Mean, Sigma2, Sigma = %lf, %lf, %lf\n",
												dMu, dSigma2, dSigma );

			sprintf( pcMsg, "Mean = %lf, Sigma = %lf", dMu, dSigma );
			_TRC_DUMP( pcMsg );

		}
	}

	_TRC_EXIT();
	_TRC_TERM();

	exit( 0 );
}
