/*
	(c)Copyright	All rights reserved.
		K.Masuda	2025.02.02

	These materials inherit <<CryptOne>>.

	   k.masuda.52431@gmailcom
	  Cell phone : 080-5444-1937

	203 NIC Heim Akabane, 22-31
	Iwabuchi-machi, Kita-ku Tokyo
			Japan	115-0041

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>

		These materials inherit <<CryptOne>>

             Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD

                 2024.01
*/

#define	RESERR	( 1e-10 )

static	double	dErf1, dErf2;

extern	double	dErf( double, double );
extern	double	dExp( double );

int		main(
int		iArgc,
char	*pcArgv[]
){
	double	dAdd, dx, dxInit, delta;
	double	dErf3, dErf4, dErf5;

	if( iArgc < 2 ){
		printf( "a.out <x> <delta>\n" );
		exit( 1 );
	}

	_TRC_INIT( "Erf" );
	_TRC_ENTR( "main" );

	dxInit = dx = atof( pcArgv[ 1 ] );
	delta = atof( pcArgv[ 2 ] );

	_TRC_DMPF( "dxInit", dxInit );
	_TRC_DMPF( "delta", delta );

/*
	for( dx = dxInit, dErf1 = dAdd = 0.0;
					0.0 <= dx - delta; dx -= delta ){
		dAdd = ( 1.0 / exp( dx * dx )
					+ 1.0 / exp( ( dx - delta ) * ( dx - delta ) ) )
					* delta / 2.0;
		_TRC_DMPF( "dAdd", dAdd );
		dErf1 += dAdd;
		_TRC_DMPF( "dErf1", dErf1 );
	}
*/

	dErf1 = dErf( dx, delta );
	_TRC_DMPF( "dErf", dErf1 );

	dErf2 = dErf1 * 2.0;
	dErf3 = sqrt( (double)3.141592654 ) / 2.0;
	dErf4 = dErf3 + dErf1;
	dErf5 = sqrt( (double)3.141592654 );
	
	printf( "Erf(%lf,%lf)\t= %lf\n",
			-10.0, dxInit, dErf4 / dErf5 );
	printf( "Erf(%lf,%lf)\t\t= %lf\n",
			-dxInit, dxInit, dErf2 / dErf5 );

	_TRC_DMPF( "dxInit", dxInit );
	_TRC_DMPF( "dx", dx );
	_TRC_DMPF( "dErf1", dErf1 );

	_TRC_EXIT();
	_TRC_TERM();

	exit( 0 );
}
