/*
	(c)Copyright	All rights reserved.
		K.Masuda	2025.02.01

	These materials inherit <<CryptOne>>.

	   k.masuda.52431@gmailcom
	  Cell phone : 080-5444-1937

	203 NIC Heim Akabane, 22-31
	Iwabuchi-machi, Kita-ku Tokyo
			Japan	115-0041

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>

		These materials inherit <<CryptOne>>

             Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD

                 2024.01
*/

#define		RESERR	( 1e-6 )

static	double	xInit, sum, sumDelta;

extern	double	dLog( double, double );
static	double	comp( double, double );

#if	0
int		main(
int		iArgc,
char	*pcArgv[]
){
	double	delta, limit;
	double	x, xInit;
	double	const1;
	double	delta1;

	if( iArgc < 3 ){
		printf( "a.out <x (>1.0)> <delta> <limit (>x)> <delta1>\n" );
		exit( 1 );
	}

	_TRC_INIT( "Log" );
	_TRC_ENTR( "main" );

	xInit	= x	= atof( pcArgv[ 1 ] );
	delta = atof( pcArgv[ 2 ] );
	limit = atof( pcArgv[ 3 ] );
	delta1	= atof( pcArgv[ 1 ] );

	_TRC_DMPF( "x", x );

	const1 = 2.302586;
	for( xInit = x = 1.0; x <= limit; x += delta ){
		sum = dLog( x, delta );
		printf( "Log( %lf, %lf ) = %lf, %lf, %lf\n",
								x, delta1, sumDelta, sum, sum / const1 );
		_TRC_DMPF( "sum", sum / const1 );
	}

	_TRC_EXIT();
	_TRC_TERM();

	exit( 0 );
}
#endif

double	dLog(
double	x,
double	delta
){
	double	dTmpVal;

	_TRC_ENTR( "dLog" );
	xInit = x;
	_TRC_DMPF( "x", x );
	if( fabs( x - 1.0 ) < RESERR ){
		return( sum = 0.0 );
	}
	if( delta < RESERR ){
		fprintf( stderr,
			"Time over of calculation, delta(%lf) too small\n", delta );
		exit( 1 );
	}
	for( x = xInit, sum = 0.0; 0.0 < ( dTmpVal = comp( x, delta ) );
					x = ( x < 1.0 ) ? x + delta : x - delta ){	
		sprintf( pcMsg, "comp(%lf,%lf) = %lf\n",
									x, delta, comp( x, delta ) );
		_TRC_DUMP( pcMsg );
		_TRC_DMPF( "x", x );
		sum += sumDelta = ( 1.0 / x + 1.0 / ( x - delta ) ) * delta / 2.0;
		_TRC_DMPF( "sum", sum );
	}

	_TRC_DMPF( "sum", sum );

	_TRC_EXIT();
	return( ( xInit < 1.0 ) ? -sum : sum );
}

double	comp(
double	x,
double	delta
){
	_TRC_ENTR( "comp" );

	_TRC_DMPF( "x", x );
	_TRC_DMPF( "delta", delta );
	_TRC_DMPF( "x - delta", x - delta );
	if( x < 0.0 ){
		fprintf( stderr, "Argument error, x < 0.0\n" );
		exit( 1 );
	}
	else{
		if( x < 1.0 ){
			_TRC_EXIT();
			return( 1.0 - x - delta );
		}
		else{
			_TRC_EXIT();
			return( x - delta );
		}
	}
}
