/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.11.30
		and Shirhill family
			<< main.c >>
*/
/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>
            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<time.h>
#include	"MyTrace.h"

/*
		_SLOW_　を定義すると、低速バージョンが生成できます。
	高速バージョンでは 1000,000 ページを約３０秒でファイル出力できます。

#define	_SLOW_
*/

/*
うむくう　むくうう　くむうう
うむうく　むうくう　くうむう
うくむう　むううく　くううむ
うくうむ
ううむく
ううくむ

むくう：　うむくう　むうくう　むくうう
むうく：　うむうく　むううく
くむう：　うくむう　くうむう　くむうう
くうむ：　うくうむ　くううむ
うむく：　ううむく
うくむ：　ううくむ
*/

#define	MAXNO	( 24 )
#define	STRMAX	( 4 )

static	int		Strs[ MAXNO ][ STRMAX ] = {
			{ 1, 2, 3, 4 }, { 1, 2, 4, 3 },
			{ 1, 3, 2, 4 }, { 1, 3, 4, 2 },
			{ 1, 4, 2, 3 }, { 1, 4, 3, 2 },
			{ 2, 1, 3, 4 }, { 2, 1, 4, 3 },
			{ 2, 3, 1, 4 }, { 2, 3, 4, 1 },
			{ 2, 4, 1, 3 }, { 2, 4, 3, 1 },
			{ 3, 1, 2, 4 }, { 3, 1, 4, 2 },
			{ 3, 2, 1, 4 }, { 3, 2, 4, 1 },
			{ 3, 4, 1, 2 }, { 3, 4, 2, 1 },
			{ 4, 1, 2, 3 }, { 4, 1, 3, 2 },
			{ 4, 2, 1, 3 }, { 4, 2, 3, 1 },
			{ 4, 3, 1, 2 }, { 4, 3, 2, 1 }
				};

static	char	*pcFEnv = "NUKARI_CONST_";
#ifdef	_SLOW_
static	char	pcInStr[ MAXNO ][ 20 ];
#endif
static	void	Seed( int, int, int );
static	int		Rand( int );

int		main(
int		iArgc,
char	*pcArgv[]
){
	int		iLp0;
	int		iLp1, iLp2, iLp3;
	int		iPage, iLine, iCols;
	struct timeval	stTime;
	struct tm		*pstTm;
	char			pcEnvStr[ 32 ];
	char			pcOrgStr[ STRMAX ][ 5 ];
	int				iInCol;
	char			*pcTmp;
#ifndef	_SLOW_
	char			pcInStr[ MAXNO ][ 20 ];
#endif

	if( iArgc < 4 ){
		printf( "Nukari <page> <line> <col>\n" );
		exit( 1 );
	}

	_TRC_INIT( "Nukari4" );
	_TRC_ENTR( "main" );

	for( iLp0 = 0; iLp0 < STRMAX; iLp0 ++ ){
		memset( pcOrgStr[ iLp0 ], 0x00, 5 );
		sprintf( pcEnvStr, "%s%d", pcFEnv, iLp0 + 1 );
		pcTmp = getenv( pcEnvStr );
		if( pcTmp == NULL ){
			printf( "Error : getenv(%s) = %s\n", pcFEnv, pcTmp );
			exit( 1 );
		}
		strcpy( pcOrgStr[ iLp0 ], pcTmp );
	}

	iPage = atoi( pcArgv[ 1 ] );
	iLine = atoi( pcArgv[ 2 ] );
	iCols = atoi( pcArgv[ 3 ] );

	_TRC_DMPD( "iPage", iPage );
	_TRC_DMPD( "iLine", iLine );
	_TRC_DMPD( "iCols", iCols );

	gettimeofday( &stTime, 0 );

	Seed( 1, stTime.tv_sec, stTime.tv_usec );
 
	for( iLp0 = 0; iLp0 < MAXNO; iLp0 ++ ){
		memset( pcInStr[ iLp0 ], 0x00, 20 );
		_TRC_DUMP( "==========" );
		_TRC_DMPD( "iLp0", iLp0 );
		for( iLp1 = 0; iLp1 < STRMAX; iLp1 ++ ){
			strcat( pcInStr[ iLp0 ], pcOrgStr[ Strs[ iLp0 ][ iLp1 ] - 1 ] );
			_TRC_DMPD( "iLp1", iLp1 );
			_TRC_DMPD( "Strs[iLp0][iLp1]", Strs[ iLp0 ][ iLp1 ] );
			_TRC_DMPS( "pcOrgStr[Strs[iLp0][iLp1]]",
									pcOrgStr[ Strs[ iLp0 ][ iLp1 ] - 1 ] );
			_TRC_DMPS( "pcInStr[iLp0]", pcInStr[ iLp0 ] );
		}
		_TRC_DMPS( "pcInStr[iLp0]", pcInStr[ iLp0 ] );
		_TRC_DUMP( "----------" );
	}
	printf( "\t(c)Copyright\tAll rights reserved.\n\t\tNukari\tMasuda\n" );
	pstTm = localtime( &stTime.tv_sec );
	printf( "\t   %02d/%02d/%02d %02d:%02d:%02d.%03d\n",
				pstTm->tm_year + 1900,
				pstTm->tm_mon + 1,
				pstTm->tm_mday,
				pstTm->tm_hour,
				pstTm->tm_min,
				pstTm->tm_sec,
				stTime.tv_usec / 1000 );
	printf( "\n\t誤った使用は 刑法203条殺人未遂罪 となります。最高刑は死刑です。\n\n" );
	for( iLp0 = 0; iLp0 < iPage; iLp0 ++ ){
#if	0
		gettimeofday( &stTime, 0 );
		pstTm = localtime( &stTime.tv_sec );
		printf( "\n\tPAGE : %d/%d\t%02d.%02d.%02d %02d:%02d:%02d.%06d\n",
					iLp0 + 1, iPage,	pstTm->tm_year - 100,
										pstTm->tm_mon + 1,
										pstTm->tm_mday,
										pstTm->tm_hour,
										pstTm->tm_min,
										pstTm->tm_sec,
										stTime.tv_usec );
#else
		printf( "\n\tPAGE : %d/%d\n", iLp0 + 1, iPage );
#endif
		for( iLp1 = 0; iLp1 < iLine; iLp1 ++ ){
			_TRC_DMPD( "iLp1", iLp1 );
			printf( "  %04d : ", iLp1 );
			for( iLp2 = 0; iLp2 < iCols; iLp2 ++ ){	
				_TRC_DMPD( "iLp2", iLp2 );
				printf( "%s.", pcInStr[ Rand( 1 ) % MAXNO ] );
			}
			printf( "\n" );
		}
	}

	_TRC_EXIT();
	_TRC_TERM();

	exit( 0 );
}

static	void	Seed(
int		int1,
int		int2,
int		int3
){
	srand( int2 + int3 );
}

static	int		Rand(
int		ind
){
	return( rand() );
}
