/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.20
		and Shirhill family
			<< main.c >>
*/
/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17
	   k.masuda.52431@gmailcom
	  Cell phone : 080-5444-1937

	203 NIC Heim Akabane, 22-31
	Iwabuchi-machi, Kita-ku Tokyo
			Japan	115-0041

	503 Grand Maison Nishi-sugamo
	1-14-3 Nishi-sugamo, Toshima-ku
		Tokyo, Japan 170-0001
	  Fax, phone : 03-5394-3324

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>
            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

#define	MAXCLASS	( 16 )
#define	MAXVAL		( 100 )

static	int		freqTbl[ MAXCLASS ];
static	char	freqGraph[ MAXVAL ];

int		main(
int		iArgc,
char	*pcArgv[]
){
	int		iLp1, iLp2;
	uint	uVal;
	struct	timeval	stTime;
	int		freqMax	= 0;
	int		freqMin	= atoi( pcArgv[ 2 ] );
	int		iClass;
	double	dVal;
	int		iTotal;;

	if( iArgc < 4 ){
		printf( "./freq <num> <sample size> <num>\n" );
		exit( 1 );
	}

	_TRC_INIT( "freq" );
	_TRC_ENTR( "main" );

	gettimeofday( &stTime, 0 );
#ifdef	SINE
	SeedSine( atoi( pcArgv[ 1 ] ), stTime.tv_sec, stTime.tv_usec );
#else
	Seed5_1( atoi( pcArgv[ 1 ] ), stTime.tv_sec, stTime.tv_usec );
#endif

	for( iLp1 = 0; iLp1 < MAXCLASS; iLp1 ++ ){
		freqTbl[ iLp1 ] = 0;
	}
	_TRC_DUMP( "Init. freqTbl" );
	for( iLp1 = 0; iLp1 < atoi( pcArgv[ 2 ] ); iLp1 ++ ){
		for( iLp2 = 0, uVal = 0;
						iLp2 < ( iTotal = atoi( pcArgv[ 3 ] ) ); iLp2 ++ ){
#ifdef	SINE
			dVal += RandSine( atoi( pcArgv[ 1 ] ) ) % MOD256;
#else
			dVal += Rand5_1( atoi( pcArgv[ 1 ] ) ) % MOD256;
#endif
		}
		dVal /= (double)iTotal;
		uVal = (int)( dVal + 0.5 );
		iClass = uVal / MAXCLASS;
		freqTbl[ iClass ] ++;
	}
	_TRC_DMPD( "freqMax", freqMax );
	for( iLp1 = 0; iLp1 < MAXCLASS; iLp1 ++ ){
		if( freqMax < freqTbl[ iLp1 ] ){
			freqMax = freqTbl[ iLp1 ];
		}
		if( freqMin > freqTbl[ iLp1 ] ){
			freqMin = freqTbl[ iLp1 ];
		}
	}
	for( iLp1 = 0; iLp1 < MAXCLASS; iLp1 ++ ){
		for( iLp2 = 0, *freqGraph = 0x00;
					iLp2 < freqTbl[ iLp1 ] * 70 / freqMax && iLp2 < MAXVAL;
					iLp2 ++ ){
			strcat( freqGraph, "*" );
		}
		printf( "%3d : %s\n", iLp1, freqGraph );
	}
	printf( "Min, Max. freq. = %d, %d\n", freqMin, freqMax );

	_TRC_EXIT();
	_TRC_TERM();
	exit( 0 );
}
